﻿using AspnCoreMvcLogging.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Diagnostics;

namespace AspnCoreMvcLogging.Controllers
{
    public class HomeController : Controller
    {
        readonly ILogger<HomeController> logger;
        public HomeController(ILogger<HomeController> log)
        {
            logger = log;
        }
        public IActionResult Index()
        {
            logger.LogInformation("Action Index :: HomeController -> executou" 
                + DateTime.Now.ToLongTimeString());
            return View();
        }
        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";
            logger.LogWarning("Action About :: HomeController -> executou"
                + DateTime.Now.ToLongTimeString());
            return View();
        }
        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";
            logger.LogTrace("Action About :: HomeController -> executou"
                + DateTime.Now.ToLongTimeString());
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}
